
#ifndef dispnodlist_h
#define dispnodlist_h

/*
* NIST STEP Editor Class Library
* cleditor/dispnodelist.h
* February, 1994
* David Sauder
* K. C. Morris

* Development of this software was funded by the United States Government,
* and is not subject to copyright.
*/

/* $Id: dispnodelist.h,v 2.0.1.1 1994/04/05 16:41:47 sauderd Exp $ */ 



#include <gennode.h>
#include <gennodeinline.h>
#include <editordefines.h>
#include <mgrnode.h>
#include <dispnode.h>
#include <gennodelist.h>

///////////////////////////////////////////////////////////////////////////////
// class DisplayNodeList
//	This will be used to represent the display state lists.
//////////////////////////////////////////////////////////////////////////////

class DisplayNodeList : public GenNodeList
{
public:
    DisplayNodeList(displayStateEnum type);
    ~DisplayNodeList() { }

// ADDED functions
    displayStateEnum GetState()	{ return listType; }

// REDEFINED functions
		// deletes node from its previous list & appends
    virtual void Append(GenericNode *node);
		// deletes newNode from its previous list & inserts in
		//	relation to existNode
    virtual void InsertAfter(GenericNode *newNode, GenericNode *existNode);
    virtual void InsertBefore(GenericNode *newNode, GenericNode *existNode);
    virtual void Remove(GenericNode *node);

protected:
private:
    displayStateEnum listType;
};

//////////////////////////////////////////////////////////////////////////////
// class DisplayNodeList inline functions
// these functions don't rely on any inline functions (its own or
//	other classes) that aren't in this file except for Generic functions
//////////////////////////////////////////////////////////////////////////////

inline DisplayNodeList::DisplayNodeList(displayStateEnum type) 
	: GenNodeList(new DisplayNode())
{
    listType = type;
    ((DisplayNode *)head)->displayState = type;
}

inline void DisplayNodeList::Remove(GenericNode *node)
{
    GenNodeList::Remove(node);
// DON'T DO THIS    ((DisplayNode *)node)->displayState = noMapState;
};

#endif
